# Notes relatives au cours

## Module 1

**Fichier texte :**
- généralement composé de caractères UTF-8
- peut être créé et modifié avec un **éditeur de texte** (!= traitement de texte, utilisant un format différent du .txt pour leurs fichiers, non lisible par un éditeur de texte)

**Langages de balisages** (par exemple *HTML*)
- contiennent des éléments de texte non rendus par le logiciel : balises, utilisées pour la structuration du document
- nécessitent un éditeur spécialisé
- peuvent être "légers" (par exemple *Markdown, Wikitexte*...) --> lisibles avec un éditeur simple 

**Pérennité et évolutivité des notes**
1. Logiciel de traitement de texte (par ex. *LibreOffice*) : permet de comparer deux versions successives d'un même document **mais** format != texte, sauvegarde et gestions de version indépendantes
2. Moteur wiki (par ex. *DocuWiki*) : accès à tous l'historique des modifications, indications précises **mais** sauvegarde à la charge de l'utilisateur, modification d'une page à la fois
3. Logiciel de gestion de version (par ex. *GitLan*) : consacrée à la partie gestion de version, arborescence, historique, examen complet **mais** sophistiquée

**Etiquettes et logiciels d'indexation**
- existence de moteurs de recherche de bureau (par ex. *DocFetcher*) : peut localiser l'occurrence d'un mot dans une collection de fichiers
- en cas d'abondance d'occurrences, l'ajout d'étiquettes / mots clés peut être utile, y compris pour des fichiers non textes

## Module 2 

**Document computationnel*

Description :
- Contenu : commentaires, code, données, résultats de calculs, liens hypertextes, images etc.
- Fonctionnalités : documentation du code, inspection explication et réexécution des calculs 
si l'environnement d'origine est disponible, possibilité d'utiliser plusieurs langage)
- Intérêts : traçabilité des calculs, accès à l'ensemble des calculs sous-jacents, présentation/partage des travaux
- Environnements possibles : Rstudio, Emacs/OrgMode, Jupyter

Pour le travail collaboratif :
- avantages : prise en main aisée, tout dans un seul document (!), transparence et réutilisation possible
- points d'attention : vérifier le fonctionnement sur chaque machine, les installations/mises à jour, fausses manips des collaborateurs
- pour la mise à disposition de façon pérenne : Gitlab, Github ou archive ouverte (HAL, figshare, zenodo)

**Intérêt de RStudio**

Les bonus +  
- historique bien structuré, traçabilité de l'inspection des données
- sauvegarde des résultats intermédiaires
- liens entre les figures et calculs établis par le code
- permet de générer des documents au format HTML, PDF, ou .doc(x)/.odt

En cas d'utilisation du langage Python, Rstudio comporte quelques limites : non complétion sur les noms de variables ;
non-persistance des variables et de leur état pour les codes Python ; seules les sorties textes sont gérées.

Trucs et astuces :
- utiliser les fonctions d'export et de réexécution du code depuis le début
- apprendre les raccourcis claviers
- lire la documentation et les pense-bêtes

**Quid des autres environnements ?**

| Environnement | Origine | Technologie | Utilisation | Navigation | Format | Article ? |
| ------ | ------ | ------ | ------ | ------ | ------ | ------ |
| Jupyter | 2001 | Web App., Python | Facile | Limitée | JSON | Difficile |
| Rstudio/knitr | 2011-2014 | IDE, Java/R | Facile  | Limitée | Rmd | Oui |
| Org-Mode | 1976/2008 | Editeur, EmacsLisp | Plus complexe | Puissante | Org | Oui|

